import http = require('http');
import Koa = require('koa');
import koaHttpProxy = require('koa-better-http-proxy');

export interface IProxy {
  [key: string]: string;
}

export interface IProxyMiddlewareOptions {
  preProxy?: (proxyReqOpts: koaHttpProxy.IRequestOption, ctx: Koa.Context)
    => (koaHttpProxy.IRequestOption | Promise<koaHttpProxy.IRequestOption>);
  postProxy?: (proxyRes: http.IncomingMessage, proxyResData: Buffer, ctx: Koa.Context) => (Buffer | Promise<Buffer>);
}

export interface IAppOptions {
  middlewares?: Koa.Middleware[];
  skipListen?: boolean;
  port?: number;
  proxy?: IProxy;
  preProxy?: IProxyMiddlewareOptions['preProxy'];
  postProxy?: IProxyMiddlewareOptions['postProxy'];
}

export interface IProxyLoadBalancerOptions {
  enableHealthCheck: boolean;
  healthCheckPath: string;
  healthCheckTimeout: number;
  healthCheckInterval: number;
}

export interface IServerConfig {
  port: number;
  proxy: {
    [key: string]: string,
  };
  proxyLoadBalanceOptions?: IProxyLoadBalancerOptions;
}
